------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Widget_Proxies is

   function heightForWidth_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;
      pragma Import (C, heightForWidth_0_virtual,
                     "__Qt4Ada_QWidget_heightForWidth_0_virtual");

   procedure inputMethodQuery_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Query : Qt4.Input_Method_Query;
     Returns : not null access Qt4.Variants.Internals.QVariant);
      pragma Import (C, inputMethodQuery_0_virtual,
                     "__Qt4Ada_QWidget_inputMethodQuery_0_virtual");

   procedure minimumSizeHint_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
      pragma Import (C, minimumSizeHint_0_virtual,
                     "__Qt4Ada_QWidget_minimumSizeHint_0_virtual");

   procedure sizeHint_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
      pragma Import (C, sizeHint_0_virtual,
                     "__Qt4Ada_QWidget_sizeHint_0_virtual");

   procedure setVisible_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Visible : Qt4.bool);
      pragma Import (C, setVisible_0_virtual,
                     "__Qt4Ada_QWidget_setVisible_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   function C_QPaintDevice_View
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null Qt_Ada.Internals.Paint_Devices.QPaintDevice_Access;
   pragma Import (C, C_QPaintDevice_View, "__QtAda_QWidget_QPaintDevice_View");

   -----------------------
   -- QPaintDevice_View --
   -----------------------

   overriding function QPaintDevice_View
    (Self : not null access constant Q_Widget_Proxy)
       return not null Qt_Ada.Internals.Paint_Devices.QPaintDevice_Access
   is
   begin
      return C_QPaintDevice_View (Self.QObject_View);
   end QPaintDevice_View;

   ------------------
   -- Paint_Engine --
   ------------------

   overriding function Paint_Engine
    (Self : not null access Q_Widget_Proxy)
       return not null access Qt4.Paint_Engines.Q_Paint_Engine
   is
   begin
      raise Program_Error;
      pragma Warnings (Off);
      return null;
      pragma Warnings (On);
   end Paint_Engine;

   pragma Style_Checks ("N");

   ----------------------
   -- Height_For_Width --
   ----------------------

   function Height_For_Width
    (Self : not null access constant Q_Widget_Proxy;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        heightForWidth_0_virtual
         (Q_Widget_Proxy'Class (Self.all).QObject_View,
          W);
   end Height_For_Width;

   ------------------------
   -- Input_Method_Query --
   ------------------------

   function Input_Method_Query
    (Self : not null access constant Q_Widget_Proxy;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      inputMethodQuery_0_virtual
       (Q_Widget_Proxy'Class (Self.all).QObject_View,
        Query,
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Input_Method_Query;

   -----------------------
   -- Minimum_Size_Hint --
   -----------------------

   function Minimum_Size_Hint
    (Self : not null access constant Q_Widget_Proxy)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      minimumSizeHint_0_virtual
       (Q_Widget_Proxy'Class (Self.all).QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Minimum_Size_Hint;

   ---------------
   -- Size_Hint --
   ---------------

   function Size_Hint
    (Self : not null access constant Q_Widget_Proxy)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      sizeHint_0_virtual
       (Q_Widget_Proxy'Class (Self.all).QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Size_Hint;

   -----------------
   -- Set_Visible --
   -----------------

   procedure Set_Visible
    (Self : not null access Q_Widget_Proxy;
     Visible : Standard.Boolean)
   is
   begin
      setVisible_0_virtual
       (Q_Widget_Proxy'Class (Self.all).QObject_View,
        Qt4.To_bool (Visible));
   end Set_Visible;

   type Q_Widget_Proxy_Access is
     access all Q_Widget_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Widget_Proxy_Access
        := new Q_Widget_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QWidget", Create'Access);
end Qt_Ada.Internals.Objects.Widget_Proxies;
